<template>
  <div>
    <modal-new-user></modal-new-user>

    <div class="row">
      <div class="ui buttons">
        <button
          class="ui button"
        >
           {{ count > 1 ? 'Users' : 'User' }}
        </button>
        <div
          class="or"
          :data-text="count"
        ></div>
        <button
          class="ui positive button"
          @click="openModalNewUser"
        >
          Ajouter
        </button>
      </div>
    </div>
    <br/>

    <div
      class="ui" :class="columns + ' column grid'"
      v-if="count"
    >
      <div
        class="column"
        v-for="user in users"
        :key="user._id"
      >
        <div class="ui cards">
          <user-card
            v-bind:user="user"
            @removeUser="removeUser"
          ></user-card>
        </div>
      </div>
    </div>

    <div class="ui header" v-else>
      Aucun utilisateur présent
    </div>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'

import { adaptiveColumns } from '@/utils/utils'
import store from '@/store/Store'
import UserCard from './UserCard'
import ModalNewUser from './ModalNewUser'

export default {
  name: 'Users',
  store,
  data () {
    return {
      columns: 'seven'
    }
  },
  beforeCreate () {
    store.dispatch('UsersStore/loadUsers')
      .then(
        (response) => {
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        }
      )
    store.dispatch('DietsStore/loadDiets')
      .then(
        (response) => {
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        }
      )
  },
  created () {
    this.columns = adaptiveColumns()
  },
  mounted () {
    // eslint-disable-next-line
    $(window).on('resize', () => {
      // eslint-disable-next-line
      this.columns = adaptiveColumns()
    })
  },
  methods: {
    removeUser (id) {
      store.dispatch('UsersStore/removeUser', id)
        .then((response) => {
          this.$toastr.s((response.firstname && response.lastname ? response.firstname + ' ' + response.lastname : response.username) + ' bien supprimé')
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        })
    },
    openModalNewUser () {
      // eslint-disable-next-line
      $('#new-user-modal')
        .modal('show')
    }
  },
  computed: {
    ...mapGetters({
      users: 'UsersStore/users',
      count: 'UsersStore/count',
      authUser: 'AuthStore/authUser'
    })
  },
  components: {
    UserCard,
    ModalNewUser
  }
}
</script>
